<?php
 
 
 

namespace PhpWA\Protocol\Proto;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\GPBUtil;
use Google\Protobuf\RepeatedField;




class MessageContextInfo extends \Google\Protobuf\Internal\Message
{
    


    protected $deviceListMetadata = null;
    


    protected $deviceListMetadataVersion = null;
    


    protected $messageSecret = null;
    


    protected $paddingBytes = null;
    


    protected $messageAddOnDurationInSecs = null;
    


    protected $botMessageSecret = null;
    


    protected $botMetadata = null;
    


    protected $reportingTokenVersion = null;
    


    protected $messageAddOnExpiryType = null;
    


    protected $messageAssociation = null;
    


    protected $capiCreatedGroup = null;
    


    protected $supportPayload = null;
    


    protected $limitSharing = null;
    


    protected $limitSharingV2 = null;
    


    private $threadId;
    


    protected $weblinkRenderConfig = null;

    























    public function __construct($data = NULL) {
        \PhpWA\Protocol\Proto\Metadata\WAProto::initOnce();
        parent::__construct($data);
    }

    



    public function getDeviceListMetadata()
    {
        return $this->deviceListMetadata;
    }

    public function hasDeviceListMetadata()
    {
        return isset($this->deviceListMetadata);
    }

    public function clearDeviceListMetadata()
    {
        unset($this->deviceListMetadata);
    }

    




    public function setDeviceListMetadata($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\DeviceListMetadata::class);
        $this->deviceListMetadata = $var;

        return $this;
    }

    



    public function getDeviceListMetadataVersion()
    {
        return isset($this->deviceListMetadataVersion) ? $this->deviceListMetadataVersion : 0;
    }

    public function hasDeviceListMetadataVersion()
    {
        return isset($this->deviceListMetadataVersion);
    }

    public function clearDeviceListMetadataVersion()
    {
        unset($this->deviceListMetadataVersion);
    }

    




    public function setDeviceListMetadataVersion($var)
    {
        GPBUtil::checkInt32($var);
        $this->deviceListMetadataVersion = $var;

        return $this;
    }

    



    public function getMessageSecret()
    {
        return isset($this->messageSecret) ? $this->messageSecret : '';
    }

    public function hasMessageSecret()
    {
        return isset($this->messageSecret);
    }

    public function clearMessageSecret()
    {
        unset($this->messageSecret);
    }

    




    public function setMessageSecret($var)
    {
        GPBUtil::checkString($var, False);
        $this->messageSecret = $var;

        return $this;
    }

    



    public function getPaddingBytes()
    {
        return isset($this->paddingBytes) ? $this->paddingBytes : '';
    }

    public function hasPaddingBytes()
    {
        return isset($this->paddingBytes);
    }

    public function clearPaddingBytes()
    {
        unset($this->paddingBytes);
    }

    




    public function setPaddingBytes($var)
    {
        GPBUtil::checkString($var, False);
        $this->paddingBytes = $var;

        return $this;
    }

    



    public function getMessageAddOnDurationInSecs()
    {
        return isset($this->messageAddOnDurationInSecs) ? $this->messageAddOnDurationInSecs : 0;
    }

    public function hasMessageAddOnDurationInSecs()
    {
        return isset($this->messageAddOnDurationInSecs);
    }

    public function clearMessageAddOnDurationInSecs()
    {
        unset($this->messageAddOnDurationInSecs);
    }

    




    public function setMessageAddOnDurationInSecs($var)
    {
        GPBUtil::checkUint32($var);
        $this->messageAddOnDurationInSecs = $var;

        return $this;
    }

    



    public function getBotMessageSecret()
    {
        return isset($this->botMessageSecret) ? $this->botMessageSecret : '';
    }

    public function hasBotMessageSecret()
    {
        return isset($this->botMessageSecret);
    }

    public function clearBotMessageSecret()
    {
        unset($this->botMessageSecret);
    }

    




    public function setBotMessageSecret($var)
    {
        GPBUtil::checkString($var, False);
        $this->botMessageSecret = $var;

        return $this;
    }

    



    public function getBotMetadata()
    {
        return $this->botMetadata;
    }

    public function hasBotMetadata()
    {
        return isset($this->botMetadata);
    }

    public function clearBotMetadata()
    {
        unset($this->botMetadata);
    }

    




    public function setBotMetadata($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\BotMetadata::class);
        $this->botMetadata = $var;

        return $this;
    }

    



    public function getReportingTokenVersion()
    {
        return isset($this->reportingTokenVersion) ? $this->reportingTokenVersion : 0;
    }

    public function hasReportingTokenVersion()
    {
        return isset($this->reportingTokenVersion);
    }

    public function clearReportingTokenVersion()
    {
        unset($this->reportingTokenVersion);
    }

    




    public function setReportingTokenVersion($var)
    {
        GPBUtil::checkInt32($var);
        $this->reportingTokenVersion = $var;

        return $this;
    }

    



    public function getMessageAddOnExpiryType()
    {
        return isset($this->messageAddOnExpiryType) ? $this->messageAddOnExpiryType : 0;
    }

    public function hasMessageAddOnExpiryType()
    {
        return isset($this->messageAddOnExpiryType);
    }

    public function clearMessageAddOnExpiryType()
    {
        unset($this->messageAddOnExpiryType);
    }

    




    public function setMessageAddOnExpiryType($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\MessageContextInfo\MessageAddonExpiryType::class);
        $this->messageAddOnExpiryType = $var;

        return $this;
    }

    



    public function getMessageAssociation()
    {
        return $this->messageAssociation;
    }

    public function hasMessageAssociation()
    {
        return isset($this->messageAssociation);
    }

    public function clearMessageAssociation()
    {
        unset($this->messageAssociation);
    }

    




    public function setMessageAssociation($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\MessageAssociation::class);
        $this->messageAssociation = $var;

        return $this;
    }

    



    public function getCapiCreatedGroup()
    {
        return isset($this->capiCreatedGroup) ? $this->capiCreatedGroup : false;
    }

    public function hasCapiCreatedGroup()
    {
        return isset($this->capiCreatedGroup);
    }

    public function clearCapiCreatedGroup()
    {
        unset($this->capiCreatedGroup);
    }

    




    public function setCapiCreatedGroup($var)
    {
        GPBUtil::checkBool($var);
        $this->capiCreatedGroup = $var;

        return $this;
    }

    



    public function getSupportPayload()
    {
        return isset($this->supportPayload) ? $this->supportPayload : '';
    }

    public function hasSupportPayload()
    {
        return isset($this->supportPayload);
    }

    public function clearSupportPayload()
    {
        unset($this->supportPayload);
    }

    




    public function setSupportPayload($var)
    {
        GPBUtil::checkString($var, True);
        $this->supportPayload = $var;

        return $this;
    }

    



    public function getLimitSharing()
    {
        return $this->limitSharing;
    }

    public function hasLimitSharing()
    {
        return isset($this->limitSharing);
    }

    public function clearLimitSharing()
    {
        unset($this->limitSharing);
    }

    




    public function setLimitSharing($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\LimitSharing::class);
        $this->limitSharing = $var;

        return $this;
    }

    



    public function getLimitSharingV2()
    {
        return $this->limitSharingV2;
    }

    public function hasLimitSharingV2()
    {
        return isset($this->limitSharingV2);
    }

    public function clearLimitSharingV2()
    {
        unset($this->limitSharingV2);
    }

    




    public function setLimitSharingV2($var)
    {
        GPBUtil::checkMessage($var, \PhpWA\Protocol\Proto\LimitSharing::class);
        $this->limitSharingV2 = $var;

        return $this;
    }

    



    public function getThreadId()
    {
        return $this->threadId;
    }

    




    public function setThreadId($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \PhpWA\Protocol\Proto\ThreadID::class);
        $this->threadId = $arr;

        return $this;
    }

    



    public function getWeblinkRenderConfig()
    {
        return isset($this->weblinkRenderConfig) ? $this->weblinkRenderConfig : 0;
    }

    public function hasWeblinkRenderConfig()
    {
        return isset($this->weblinkRenderConfig);
    }

    public function clearWeblinkRenderConfig()
    {
        unset($this->weblinkRenderConfig);
    }

    




    public function setWeblinkRenderConfig($var)
    {
        GPBUtil::checkEnum($var, \PhpWA\Protocol\Proto\WebLinkRenderConfig::class);
        $this->weblinkRenderConfig = $var;

        return $this;
    }

}

